local G = GLOBAL

local STRINGS = G.STRINGS
local require = G.require
local Recipe = G.Recipe
local Ingredient = G.Ingredient
local RECIPETABS = G.RECIPETABS
local TECH = G.TECH
local State = G.State
local TimeEvent = G.TimeEvent
local EventHandler = G.EventHandler
local FRAMES = G.FRAMES
local Action = G.Action
local ActionHandler = G.ActionHandler
local FindEntity = G.FindEntity
local GetWorld = G.GetWorld
local TheInput = G.TheInput
local IsPaused = G.IsPaused
local Vector3 = G.Vector3
local SpawnPrefab = G.SpawnPrefab
local ACTIONS = G.ACTIONS
local GetPlayer = G.GetPlayer
local GetString = G.GetString

modimport("scripts/play_wharang.lua")
modimport("scripts/cookpotfix_wharang.lua")
--modimport("scripts/wharang_strings.lua") --改，禁用
modimport("scripts/wharang_tuning.lua")
modimport("scripts/wharang_api.lua")

local Collect_SoulHeart = GetModConfigData("soulheart")
local BurnPartyTime = GetModConfigData("partytime")
local Options_CallPet = GetModConfigData("callpet")
local Miho_Build = GetModConfigData("miho_build")
local Wharang_Stats = GetModConfigData("wharang_stat")

--STRINGS.CHARACTERS.WHARANG = require "speech_wharang" --改，禁用

PrefabFiles = {
	"wharang",
	
	"wharang_dango",
	"wharang_foxhat",
	
	"handfan",
	"gumifan",
	"flute_flame",
	"flute_frost",
	"flute_healing",
	"sakurahat",
	"firepit_ghost",
	"firepit_chill",
	"gumipot",
	"wall_asia",
	"asiahouse",
	"asiahouse2",
	"moondumplings",
	"songpyeon",
	"driedcroaker",
	"mihobell",
	"peppertreeroot",
	"turf_asia",
	"turf_orient",
	"turf_flamerose",
	"miho",
	"reddrake",
	"foxfire",
	"shadowbeak",
	"miregg",
	"mir",
	"wharang_fx",
	"firepit_ghost_fire",
	"firepit_chill_fire",
	
	"fox_fish_blackgoldfish",
	"fox_fish_redgoldfish",
}

Assets = {
    
	Asset( "IMAGE", "images/saveslot_portraits/wharang.tex" ),
    Asset( "ATLAS", "images/saveslot_portraits/wharang.xml" ),
	
    Asset( "IMAGE", "images/selectscreen_portraits/wharang.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/wharang.xml" ),
	
    Asset( "IMAGE", "images/selectscreen_portraits/wharang_silho.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/wharang_silho.xml" ),
	
    Asset( "IMAGE", "bigportraits/wharang.tex" ),
    Asset( "ATLAS", "bigportraits/wharang.xml" ),
	
	Asset( "IMAGE", "images/minimapicons/wharang.tex" ),
	Asset( "ATLAS", "images/minimapicons/wharang.xml" ),
	
	Asset( "IMAGE", "images/minimapicons/wharang_evil.tex" ),
	Asset( "ATLAS", "images/minimapicons/wharang_evil.xml" ),
	
    Asset( "IMAGE", "images/tabs/yinyangtab.tex"),
	Asset( "ATLAS", "images/tabs/yinyangtab.xml"),
	
	Asset( "ANIM", "anim/wharang_sanity_badge.zip"),
	Asset( "ANIM", "anim/wharang_sanity_badge_dlc.zip"),

	
	Asset( "ANIM", "anim/wharang_fx_spirit.zip" ),
	Asset( "ANIM", "anim/wharang_fx_spirit_evil.zip" ),
	Asset( "ANIM", "anim/wharang_fx_fire.zip" ),
	Asset( "ANIM", "anim/wharang_fx_ground_fire.zip" ),
	Asset( "ANIM", "anim/wharang_fx_ring.zip" ),
	
	Asset( "ANIM", "anim/handfan.zip" ),
	Asset( "ANIM", "anim/swap_handfan.zip" ),
	Asset( "ANIM", "anim/gumifan.zip" ),
	Asset( "ANIM", "anim/swap_gumifan.zip" ),
	
	Asset( "ANIM", "anim/miregg.zip" ),
	Asset( "ANIM", "anim/mir.zip" ),
	Asset( "ANIM", "anim/miho.zip" ),
	Asset( "ANIM", "anim/mihobell.zip" ),
	
	Asset( "ANIM", "anim/gumipot.zip" ),
	
	Asset( "ANIM", "anim/sakurahat.zip" ),
	Asset( "ANIM", "anim/swap_sakurahat.zip" ),
	
    Asset("ANIM", "anim/wharang_foxhat.zip"),
	Asset("ANIM", "anim/wharang_swap_foxhat.zip"),
	
	
	Asset("ANIM", "anim/fox_fish_redgoldfish.zip"),
	Asset("ANIM", "anim/fox_fish_redgoldfish01.zip"),
	Asset("ANIM", "anim/fox_fish_blackgoldfish.zip"),
	Asset("ANIM", "anim/fox_fish_blackgoldfish01.zip"),

	Asset("ANIM", "anim/fox_firepit_hot.zip"),
	Asset("ANIM", "anim/fox_firepit_cold.zip"),
	Asset("ANIM", "anim/fox_coldfire_fire.zip"),
	
	
	Asset( "IMAGE", "images/inventoryimages/handfan.tex" ),
	Asset( "ATLAS", "images/inventoryimages/handfan.xml" ),
	Asset( "IMAGE", "images/inventoryimages/gumifan.tex" ),
	Asset( "ATLAS", "images/inventoryimages/gumifan.xml" ),
	Asset( "IMAGE", "images/inventoryimages/mihobell.tex" ),
	Asset( "ATLAS", "images/inventoryimages/mihobell.xml" ),
	Asset( "IMAGE", "images/inventoryimages/gumipot.tex" ),
	Asset( "ATLAS", "images/inventoryimages/gumipot.xml" ),
	Asset( "IMAGE", "images/inventoryimages/sakurahat.tex" ),
	Asset( "ATLAS", "images/inventoryimages/sakurahat.xml" ),
	Asset("IMAGE", "images/inventoryimages/foxmask.tex" ),
	Asset("ATLAS", "images/inventoryimages/foxmask.xml"),
	Asset("ATLAS", "images/inventoryimages/redgoldfish.xml"),
	Asset("ATLAS", "images/inventoryimages/redgoldfish_cooked.xml"),
	Asset("ATLAS", "images/inventoryimages/blackgoldfish.xml"),
	Asset("ATLAS", "images/inventoryimages/blackgoldfish_cooked.xml"),
	Asset("IMAGE", "images/inventoryimages/firepit_ghost.tex" ),
	Asset("ATLAS", "images/inventoryimages/firepit_ghost.xml"),
	Asset("IMAGE", "images/inventoryimages/firepit_chill.tex" ),
	Asset("ATLAS", "images/inventoryimages/firepit_chill.xml"),

	Asset( "IMAGE", "images/minimapicons/miregg.tex" ),
	Asset( "ATLAS", "images/minimapicons/miregg.xml" ),
	Asset( "IMAGE", "images/minimapicons/mir.tex" ),
	Asset( "ATLAS", "images/minimapicons/mir.xml" ),
	Asset( "IMAGE", "images/minimapicons/miho.tex" ),
	Asset( "ATLAS", "images/minimapicons/miho.xml" ),
	Asset( "IMAGE", "images/minimapicons/mihobell.tex" ),
	Asset( "ATLAS", "images/minimapicons/mihobell.xml" ),
	Asset( "IMAGE", "images/minimapicons/handfan.tex" ),
	Asset( "ATLAS", "images/minimapicons/handfan.xml" ),
	Asset( "IMAGE", "images/minimapicons/gumifan.tex" ),
	Asset( "ATLAS", "images/minimapicons/gumifan.xml" ),
	Asset( "IMAGE", "images/minimapicons/gumipot.tex" ),
	Asset( "ATLAS", "images/minimapicons/gumipot.xml" ),
	
	Asset("ANIM", "anim/moondumplings.zip"),
	Asset("IMAGE", "images/inventoryimages/moondumplings.tex" ),
	Asset("ATLAS", "images/inventoryimages/moondumplings.xml"),
	Asset("IMAGE", "images/inventoryimages/moondumplings_evil.tex" ),
	Asset("ATLAS", "images/inventoryimages/moondumplings_evil.xml"),
	
	Asset("ANIM", "anim/driedcroaker.zip"),
	Asset("IMAGE", "images/inventoryimages/driedcroaker.tex" ),
    Asset("ATLAS", "images/inventoryimages/driedcroaker.xml"),
	
	Asset("ANIM", "anim/songpyeon.zip"),
	Asset("IMAGE", "images/inventoryimages/songpyeon.tex" ),
    Asset("ATLAS", "images/inventoryimages/songpyeon.xml"),
	
	Asset("ANIM", "anim/flute_flame.zip"),
	Asset("IMAGE", "images/inventoryimages/flute_flame.tex" ),
	Asset("ATLAS", "images/inventoryimages/flute_flame.xml"),
	
	Asset("ANIM", "anim/flute_frost.zip"),
	Asset("IMAGE", "images/inventoryimages/flute_frost.tex" ),
	Asset("ATLAS", "images/inventoryimages/flute_frost.xml"),
	
	Asset("ANIM", "anim/flute_healing.zip"),
	Asset("IMAGE", "images/inventoryimages/flute_healing.tex" ),
	Asset("ATLAS", "images/inventoryimages/flute_healing.xml"),
	
	Asset("ANIM", "anim/peppertreeroot.zip"),
	Asset("IMAGE", "images/inventoryimages/peppertreeroot.tex" ),
	Asset("ATLAS", "images/inventoryimages/peppertreeroot.xml"),
	
	Asset("ANIM", "anim/wall.zip"),
	Asset("ANIM", "anim/wall_asia.zip"),
	Asset("IMAGE", "images/inventoryimages/wall_asia_item.tex" ),
	Asset("ATLAS", "images/inventoryimages/wall_asia_item.xml"),
	
	Asset( "ANIM", "anim/asiahouse.zip" ),
	Asset( "IMAGE", "images/inventoryimages/asiahouse.tex" ),
	Asset( "ATLAS", "images/inventoryimages/asiahouse.xml" ),
	Asset( "IMAGE", "images/minimapicons/asiahouse.tex" ),
	Asset( "ATLAS", "images/minimapicons/asiahouse.xml" ),
	
	Asset( "ANIM", "anim/asiahouse2.zip" ),
	Asset( "IMAGE", "images/inventoryimages/asiahouse2.tex" ),
	Asset( "ATLAS", "images/inventoryimages/asiahouse2.xml" ),
	Asset( "IMAGE", "images/minimapicons/asiahouse2.tex" ),
	Asset( "ATLAS", "images/minimapicons/asiahouse2.xml" ),
	
	Asset( "ANIM", "anim/wharang_turf.zip" ),
	Asset( "ATLAS", "images/inventoryimages/turf_asia.xml" ),
	Asset( "ATLAS", "images/inventoryimages/turf_orient.xml" ),
	Asset( "ATLAS", "images/inventoryimages/turf_flamerose.xml" ),
	
	Asset( "ANIM", "anim/reddrake.zip"),
	Asset( "ANIM", "anim/orangedrake.zip"),
	Asset( "ANIM", "anim/golddrake.zip"),
	Asset( "IMAGE", "images/minimapicons/peppertree_1.tex" ),
	Asset( "ATLAS", "images/minimapicons/peppertree_1.xml" ),
	Asset( "IMAGE", "images/minimapicons/peppertree_2.tex" ),
	Asset( "ATLAS", "images/minimapicons/peppertree_2.xml" ),
	Asset( "IMAGE", "images/minimapicons/peppertree_3.tex" ),
	Asset( "ATLAS", "images/minimapicons/peppertree_3.xml" ),
	
	
	------------------------------------------------------------------
	
	-- new
	
	Asset( "ANIM", "anim/wharang_dango.zip" ),
	Asset( "IMAGE", "images/inventoryimages/wharang_dango.tex" ),
	Asset( "ATLAS", "images/inventoryimages/wharang_dango.xml" ),
	
	------------------------------------------------------------------
	
	-- sound
	
	Asset( "SOUND" , "sound/millenniumfox.fsb" ),
	Asset( "SOUNDPACKAGE" , "sound/millenniumfox.fev" ),
	
}

----------------------------------------------------------------
-- Add Character
----------------------------------------------------------------

table.insert(G.CHARACTER_GENDERS.FEMALE, "wharang")
AddModCharacter("wharang")

----------------------------------------------------------------
-- Voice
----------------------------------------------------------------

RemapSoundEvent("dontstarve/characters/wharang_evilwhite/death_voice", "millenniumfox/characters/wharang_white/death_voice")
RemapSoundEvent("dontstarve/characters/wharang_evilwhite/hurt", "millenniumfox/characters/wharang_white/hurt")
RemapSoundEvent("dontstarve/characters/wharang_evilwhite/talk_LP", "millenniumfox/characters/wharang_white/talk_LP")

----------------------------------------------------------------
-- Minimap Icon
----------------------------------------------------------------

AddMinimapAtlas("images/minimapicons/wharang.xml")
AddMinimapAtlas("images/minimapicons/wharang_evil.xml")
AddMinimapAtlas("images/minimapicons/mihobell.xml")
AddMinimapAtlas("images/minimapicons/miho.xml")
AddMinimapAtlas("images/minimapicons/handfan.xml")
AddMinimapAtlas("images/minimapicons/gumifan.xml")
AddMinimapAtlas("images/minimapicons/gumipot.xml")
AddMinimapAtlas("images/minimapicons/firepit_h.xml")
AddMinimapAtlas("images/minimapicons/firepit_c.xml")
AddMinimapAtlas("images/minimapicons/asiahouse.xml")
AddMinimapAtlas("images/minimapicons/asiahouse2.xml")
AddMinimapAtlas("images/minimapicons/miregg.xml")
AddMinimapAtlas("images/minimapicons/mir.xml")
AddMinimapAtlas("images/minimapicons/peppertree_1.xml")
AddMinimapAtlas("images/minimapicons/peppertree_2.xml")
AddMinimapAtlas("images/minimapicons/peppertree_3.xml")

----------------------------------------------------------------
-- DLC Enable
----------------------------------------------------------------

G.IsROG = false

if G.IsDLCEnabled(G.REIGN_OF_GIANTS) then
	G.IsROG = true
end


G.IsSW = false

if G.IsDLCEnabled(G.CAPY_DLC) then
	G.IsSW = true
end

G.IsHAM = false

if G.IsDLCEnabled(G.PORKLAND_DLC) then
	G.IsHAM = true
end

----------------------------------------------------------------
-- Recipe Tab
----------------------------------------------------------------

AddClassPostConstruct("widgets/crafttabs", function(inst)
    if inst.prefab == "wharang" then
		G.RECIPETABS['YINYANG'] = {str = "YINYANG", sort= 99, icon = "yinyangtab.tex", icon_atlas = "images/tabs/yinyangtab.xml"}
		table.insert(tabnames, G.RECIPETABS['YINYANG'])
    end
end)

----------------------------------------------------------------
-- Recipes
----------------------------------------------------------------

local function ingredientatlas(ingred,count,atlas)
	local frecipe = Ingredient(ingred,count)
		frecipe.atlas = atlas
	return frecipe
end

function Wharang_Recipes(wharang)
if (GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) or GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC)) then
	local FirePit_Ghost = Recipe( "firepit_ghost", { Ingredient("goldnugget", 15), Ingredient("cutstone", 6), Ingredient("nitre", 3) }, RECIPETABS.YINYANG, {SCIENCE = 0}, GLOBAL.RECIPE_GAME_TYPE.COMMON, "firepit_ghost_placer", 2 )
	FirePit_Ghost.atlas = "images/inventoryimages/firepit_ghost.xml"
	
	local FirePit_Chill = Recipe( "firepit_chill", { Ingredient("goldnugget", 15), Ingredient("cutstone", 6), Ingredient("nitre", 4) }, RECIPETABS.YINYANG, {SCIENCE = 0}, GLOBAL.RECIPE_GAME_TYPE.COMMON, "firepit_chill_placer", 2 )
	FirePit_Chill.atlas = "images/inventoryimages/firepit_chill.xml"
	
	
		local MoonDumplings = Recipe( "wharang_dango", { Ingredient("berries", 4), Ingredient("seeds_cooked", 3) }, RECIPETABS.YINYANG, {SCIENCE = 0}, GLOBAL.RECIPE_GAME_TYPE.COMMON )
        MoonDumplings.atlas = "images/inventoryimages/wharang_dango.xml"
		
		local GumiFan = Recipe( "gumifan", { Ingredient("handfan", 1,"images/inventoryimages/handfan.xml"), Ingredient("rope", 2), Ingredient("goldnugget", 2) }, RECIPETABS.YINYANG, {SCIENCE = 0}, GLOBAL.RECIPE_GAME_TYPE.COMMON )
        GumiFan.atlas = "images/inventoryimages/gumifan.xml"

		local SakuraHat = Recipe( "sakurahat", { Ingredient("petals", 10), Ingredient("cutgrass", 3) }, RECIPETABS.YINYANG, {SCIENCE = 0}, GLOBAL.RECIPE_GAME_TYPE.COMMON )
        SakuraHat.atlas = "images/inventoryimages/sakurahat.xml"
		local FoxMask = Recipe( "foxmask", { Ingredient("goldnugget", 1), Ingredient("pigskin", 4), Ingredient("nightmarefuel", 2) }, RECIPETABS.YINYANG, {SCIENCE = 0}, GLOBAL.RECIPE_GAME_TYPE.COMMON )
        FoxMask.atlas = "images/inventoryimages/foxmask.xml"

		local Flute_Flame = Recipe( "flute_flame", { Ingredient("cutgrass",5), Ingredient("feather_robin", 10), Ingredient("goldnugget", 4) }, RECIPETABS.YINYANG, TECH.SCIENCE_ONE, GLOBAL.RECIPE_GAME_TYPE.COMMON )
        Flute_Flame.atlas = "images/inventoryimages/flute_flame.xml"
		local Flute_Frost = Recipe( "flute_frost", { Ingredient("cutgrass",5), Ingredient("feather_robin_winter", 5), Ingredient("goldnugget", 4) }, RECIPETABS.YINYANG, TECH.SCIENCE_ONE, GLOBAL.RECIPE_GAME_TYPE.COMMON )
        Flute_Frost.atlas = "images/inventoryimages/flute_frost.xml"
		local Flute_Healing = Recipe( "flute_healing", { Ingredient("cutgrass",5), Ingredient("feather_crow", 10), Ingredient("goldnugget", 4) }, RECIPETABS.YINYANG, TECH.SCIENCE_ONE, GLOBAL.RECIPE_GAME_TYPE.COMMON )
        Flute_Healing.atlas = "images/inventoryimages/flute_healing.xml"
	
		local AsiaWall = Recipe( "wall_asia_item", { Ingredient("log", 6), Ingredient("cutstone", 2) }, RECIPETABS.YINYANG, {SCIENCE = 0}, nil, nil, nil, 4 )
        AsiaWall.atlas = "images/inventoryimages/wall_asia_item.xml"
        
	local OngGi = Recipe( "gumipot", { Ingredient("boards", 8), Ingredient("cutstone", 12) }, RECIPETABS.YINYANG, {SCIENCE = 0}, GLOBAL.RECIPE_GAME_TYPE.COMMON, "gumipot_placer", .9 )
	OngGi.atlas = "images/inventoryimages/gumipot.xml"
	local AsiaHouse = Recipe( "asiahouse", { Ingredient("boards", 10), Ingredient("wall_stone_item", 40), Ingredient("redgem", 2) }, RECIPETABS.YINYANG, {SCIENCE = 2}, GLOBAL.RECIPE_GAME_TYPE.COMMON, "asiahouse_placer", 4 )
	AsiaHouse.atlas = "images/inventoryimages/asiahouse.xml"
	local AsiaHouse2 = Recipe( "asiahouse2", { Ingredient("goldnugget", 4), Ingredient("wall_wood_item", 40), Ingredient("bluegem", 2) }, RECIPETABS.YINYANG, {SCIENCE = 2}, GLOBAL.RECIPE_GAME_TYPE.COMMON, "asiahouse2_placer", 4 )
	AsiaHouse2.atlas = "images/inventoryimages/asiahouse2.xml"
	
	local Turf_Asia = Recipe( "turf_asia", { Ingredient("beefalowool", 2), Ingredient("silk", 1) }, RECIPETABS.YINYANG, {SCIENCE = 0}, nil, nil, nil, 4 )
	Turf_Asia.atlas = "images/inventoryimages/turf_asia.xml"
	local Turf_Orient = Recipe( "turf_orient", { Ingredient("beefalowool", 2), Ingredient("silk", 1) }, RECIPETABS.YINYANG, {SCIENCE = 0}, nil, nil, nil, 4 )
	Turf_Orient.atlas = "images/inventoryimages/turf_orient.xml"
	local Turf_Flame_Rose = Recipe( "turf_flamerose", { Ingredient("beefalowool", 1), Ingredient("petals", 3) }, RECIPETABS.YINYANG, {SCIENCE = 0}, nil, nil, nil, 4 )
	Turf_Flame_Rose.atlas = "images/inventoryimages/turf_flamerose.xml"
	
elseif not (GLOBAL.IsDLCEnabled(GLOBAL.CAPY_DLC) or GLOBAL.IsDLCEnabled(GLOBAL.PORKLAND_DLC)) then
	local FirePit_Ghost = Recipe( "firepit_ghost", { Ingredient("goldnugget", 15), Ingredient("cutstone", 6), Ingredient("nitre", 3) }, RECIPETABS.YINYANG, {SCIENCE = 0}, "firepit_ghost_placer", 2 )
	FirePit_Ghost.atlas = "images/inventoryimages/firepit_ghost.xml"
		if GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS) then
			local FirePit_Chill = Recipe( "firepit_chill", { Ingredient("goldnugget", 15), Ingredient("cutstone", 6), Ingredient("nitre", 4) }, RECIPETABS.YINYANG, {SCIENCE = 0}, "firepit_chill_placer", 2 )
			FirePit_Chill.atlas = "images/inventoryimages/firepit_chill.xml"
		end
		
		local MoonDumplings = Recipe( "wharang_dango", { Ingredient("berries", 4), Ingredient("seeds_cooked", 3) }, RECIPETABS.YINYANG, {SCIENCE = 0} )
        MoonDumplings.atlas = "images/inventoryimages/wharang_dango.xml"
		
		local GumiFan = Recipe( "gumifan", { Ingredient("handfan", 1,"images/inventoryimages/handfan.xml"), Ingredient("rope", 2), Ingredient("goldnugget", 2) }, RECIPETABS.YINYANG, {SCIENCE = 0} )
        GumiFan.atlas = "images/inventoryimages/gumifan.xml"

		local SakuraHat = Recipe( "sakurahat", { Ingredient("petals", 10), Ingredient("cutgrass", 3) }, RECIPETABS.YINYANG, {SCIENCE = 0} )
        SakuraHat.atlas = "images/inventoryimages/sakurahat.xml"
		local FoxMask = Recipe( "foxmask", { Ingredient("goldnugget", 1), Ingredient("manrabbit_tail", 4), Ingredient("nightmarefuel", 2) }, RECIPETABS.YINYANG, {SCIENCE = 0} )
        FoxMask.atlas = "images/inventoryimages/foxmask.xml"

		local Flute_Flame = Recipe( "flute_flame", { Ingredient("cutreeds",5), Ingredient("feather_robin", 10), Ingredient("goldnugget", 4) }, RECIPETABS.YINYANG, TECH.SCIENCE_ONE )
        Flute_Flame.atlas = "images/inventoryimages/flute_flame.xml"
		local Flute_Frost = Recipe( "flute_frost", { Ingredient("cutreeds",5), Ingredient("feather_robin_winter", 10), Ingredient("goldnugget", 4) }, RECIPETABS.YINYANG, TECH.SCIENCE_ONE )
        Flute_Frost.atlas = "images/inventoryimages/flute_frost.xml"
		local Flute_Healing = Recipe( "flute_healing", { Ingredient("cutreeds",5), Ingredient("feather_crow", 10), Ingredient("goldnugget", 4) }, RECIPETABS.YINYANG, TECH.SCIENCE_ONE )
        Flute_Healing.atlas = "images/inventoryimages/flute_healing.xml"

		--local AsiaWall = Recipe( "wall_asia_item", { Ingredient("log", 6), Ingredient("cutstone", 2) }, RECIPETABS.YINYANG, {SCIENCE = 0}, nil, nil, nil, 4 )
        --AsiaWall.atlas = "images/inventoryimages/wall_asia_item.xml"
		
		
	local OngGi = Recipe( "gumipot", { Ingredient("boards", 8), Ingredient("cutstone", 12) }, RECIPETABS.YINYANG, {SCIENCE = 0}, "gumipot_placer", .9 )
	OngGi.atlas = "images/inventoryimages/gumipot.xml"
	local AsiaHouse = Recipe( "asiahouse", { Ingredient("boards", 10), Ingredient("wall_stone_item", 40), Ingredient("redgem", 2) }, RECIPETABS.YINYANG, TECH.ANCIENT_TWO, "asiahouse_placer", 4 )
	AsiaHouse.atlas = "images/inventoryimages/asiahouse.xml"
	local AsiaHouse2 = Recipe( "asiahouse2", { Ingredient("goldnugget", 4), Ingredient("wall_wood_item", 40), Ingredient("bluegem", 2) }, RECIPETABS.YINYANG, TECH.ANCIENT_TWO, "asiahouse2_placer", 4 )
	AsiaHouse2.atlas = "images/inventoryimages/asiahouse2.xml"
	--[[
	local Turf_Asia = Recipe( "turf_asia", { Ingredient("beefalowool", 2), Ingredient("silk", 1) }, RECIPETABS.YINYANG, {SCIENCE = 0}, nil, nil, nil, 4 )
	Turf_Asia.atlas = "images/inventoryimages/turf_asia.xml"
	local Turf_Orient = Recipe( "turf_orient", { Ingredient("beefalowool", 2), Ingredient("silk", 1) }, RECIPETABS.YINYANG, {SCIENCE = 0}, nil, nil, nil, 4 )
	Turf_Orient.atlas = "images/inventoryimages/turf_orient.xml"
	local Turf_Flame_Rose = Recipe( "turf_flamerose", { Ingredient("beefalowool", 1), Ingredient("petals", 3) }, RECIPETABS.YINYANG, {SCIENCE = 0}, nil, nil, nil, 4 )
	Turf_Flame_Rose.atlas = "images/inventoryimages/turf_flamerose.xml"
	--]]
end
end

AddGamePostInit(modGamePostInit)

AddSimPostInit(function(inst)
	if inst.prefab == "wharang" then
		Wharang_Recipes(inst)
	end
end)

----------------------------------------------------------------
-- Maxwell Intro
----------------------------------------------------------------

local function Wharang_MaxwellIntro(inst)
    if GLOBAL.GetPlayer().prefab == "wharang" then
        inst.components.maxwelltalker.speeches.SANDBOX_1 =
        {
            appearsound = "dontstarve/maxwell/disappear",	
            voice = "dontstarve/maxwell/talk_LP_world3",
            appearanim = "appear3",
            idleanim = "idle3_loop",
            dialogpreanim = "dialog3_pre",
            dialoganim ="dialog3_loop",
            dialogpostanim = "dialog3_pst",
            disappearanim = "disappear3",
            disableplayer = true,
            skippable = true,
            {
                string = STRINGS.WHARANG_INTRO_MAXWELL_1,
                wait = 2.5,
                anim = nil,
                sound = nil,
            },
            {
                string = STRINGS.WHARANG_INTRO_MAXWELL_2,
                wait = 4,
                anim = nil,
                sound = nil,
            },
            {
                string = STRINGS.WHARANG_INTRO_MAXWELL_3,
                wait = 3.5,
                anim = nil,
                sound = nil,
            },
        }
    end
end

AddPrefabPostInit("maxwellintro", Wharang_MaxwellIntro)


----------------------------------------------------------------
-- Fishing Pond
----------------------------------------------------------------

local function Wharang_Fishable(inst)
	if GetPlayer() and GetPlayer().prefab == "wharang" then
		inst.components.fishable:AddFish("redgoldfish")
		inst.components.fishable:AddFish("blackgoldfish")
	end
end

AddPrefabPostInit("pond", Wharang_Fishable)
AddPrefabPostInit("pond_mos", Wharang_Fishable)

----------------------------------------------------------------
-- Dry Meat
----------------------------------------------------------------

local function Wharang_DryMeat(inst)
	local function onstartdrying(inst, dryable)
	 
		if dryable == "redgoldfish" or dryable == "blackgoldfish" then
			dryable = "fish"
		end
	 
		inst.AnimState:PlayAnimation("drying_pre")
		inst.AnimState:PushAnimation("drying_loop", true)
		inst.AnimState:OverrideSymbol("swap_dried", "meat_rack_food", dryable)
	end

	inst.components.dryer:SetStartDryingFn(onstartdrying)
	inst.components.dryer:SetContinueDryingFn(onstartdrying)
end

AddPrefabPostInit("meatrack", Wharang_DryMeat)

----------------------------------------------------------------
-- Friendly Bat
----------------------------------------------------------------

local function Wharang_Bat(inst)
	local function Retarget(inst)
		local ta = inst.components.teamattacker
		local newtarget = G.FindEntity(inst, TUNING.BISHOP_TARGET_DIST, function(guy)
				return (guy:HasTag("character") or guy:HasTag("monster") )
					   and not guy:HasTag("bat")
					   and not (inst.prefab ~= "wharang")
					   and inst.components.combat:CanTarget(guy)
		end)
		if newtarget and not ta.inteam and not ta:SearchForTeam() then
			MakeTeam(inst, newtarget)
		end
		if ta.inteam and not ta.teamleader:CanAttack() then
			return newtarget
		end
	end

	inst.components.combat:SetRetargetFunction(3, Retarget)
end

AddPrefabPostInit("bat", Wharang_Bat)

----------------------------------------------------------------
-- Pepper Tree Loots
----------------------------------------------------------------

local function Wharang_PepperTreeLiving(inst)
	if G.GetPlayer().prefab == "wharang" then
		if inst.components.lootdropper then
			inst.components.lootdropper:AddChanceLoot("peppertreeroot", 1)
		end
	end
end

AddPrefabPostInit("livingtree", Wharang_PepperTreeLiving)

local function WhaRang_PepperTreeGuard(inst)
	if G.GetPlayer().prefab == "wharang" then
		if inst.components.lootdropper then
			inst.components.lootdropper:AddChanceLoot("peppertreeroot", 0.5)
		end
	end
end

AddPrefabPostInit("leif", WhaRang_PepperTreeGuard)
AddPrefabPostInit("leif_sparse", WhaRang_PepperTreeGuard)

----------------------------------------------------------------
-- Sanity Badge
----------------------------------------------------------------

local function Wharang_Badge(class, owner)
	if G.GetPlayer().prefab == "wharang" then
		class.brain.anim:GetAnimState():SetBuild("wharang_sanity")
	end
end

local function Wharang_Badge_dlc(class, owner)
	if G.GetPlayer().prefab == "wharang" then
		class.brain.anim:GetAnimState():SetBuild("wharang_sanity_rog")
	end
end

if G.IsROG or G.IsSW or G.IsHAM then
	AddClassPostConstruct("widgets/statusdisplays", Wharang_Badge_dlc)
else
	AddClassPostConstruct("widgets/statusdisplays", Wharang_Badge)
end

----------------------------------------------------------------
-- Inventory Slot Color
----------------------------------------------------------------

local function TintingPostInit(self, num, atlas, bgim, owner, container)
	if container.widgetbgimagetint then
		self.bgimage:SetTint(container.widgetbgimagetint.r, container.widgetbgimagetint.g, container.widgetbgimagetint.b, container.widgetbgimagetint.a)
	end
end

AddClassPostConstruct("widgets/invslot", TintingPostInit)

----------------------------------------------------------------
-- Other Mods Compatible
----------------------------------------------------------------

local function IsModEnabled(name)
	for _, moddir in ipairs(GLOBAL.KnownModIndex:GetModsToLoad()) do
		if GLOBAL.KnownModIndex:GetModInfo(moddir).name == "RPG HUD"  then
			return true
		end
	end
	return false
end

local function BetterWallsIsModEnabled(name)
	for _, moddir in ipairs(GLOBAL.KnownModIndex:GetModsToLoad()) do
		if GLOBAL.KnownModIndex:GetModInfo(moddir).name == "BetterWalls"  then
			return true
		end
	end
	return false
end

if BetterWallsIsModEnabled("BetterWalls") then
local showWallLabel = false
local BODYTEXTFONT = GLOBAL.BODYTEXTFONT
local function WallUpdateLabel(inst)
	if not enableWallLabel then return end
	if showWallLabel then
		local hc = math.floor(inst.components.health.currenthealth + 0.5)
		local hm = math.floor(inst.components.health:GetMaxHealth() + 0.5)
		local hp = math.floor(hc*100/hm + 0.5)
		local hstr = tostring(hc) .. "\n" .. tostring(hp).."\37"
		if hp > 50 then
			inst.Label:SetColour(12/255,236/255,154/255)
		elseif hp > 20 then
			inst.Label:SetColour(1,1,0)
		else
			inst.Label:SetColour(1,0,0)
		end
		inst.Label:SetText(hstr)
	end
	inst.Label:Enable(showWallLabel) 
end
local function WallAddLabel(inst)
	inst.entity:AddLabel()
	inst.Label:SetFontSize(14)
	inst.Label:SetFont(BODYTEXTFONT)
	inst.Label:SetPos(0, 1, 0)
	inst.Label:SetText("")
	inst.Label:SetColour(12/255,236/255,154/255)
end
local function BetterWallInit(inst)
	WallAddLabel(inst)
end
AddPrefabPostInit("wall_asia", BetterWallInit)
end

----------------------------------------------------------------
-- Turfs
----------------------------------------------------------------
--[[
	local WHARANG_TURFS = {
		[GLOBAL.GROUND.ASIA] = "turf_asia",
		[GLOBAL.GROUND.ORIENT] = "turf_orient",
		[GLOBAL.GROUND.FLAMEROSE] = "turf_flamerose",
	}

AddComponentPostInit("terraformer", function(self)
	local function SpawnTurf(turf, pt)
		if turf then
			local loot = GLOBAL.SpawnPrefab(turf)
			loot.Transform:SetPosition(pt.x, pt.y, pt.z)
			if loot.Physics then
				local angle = math.random()*2*GLOBAL.PI
				loot.Physics:SetVel(2*math.cos(angle), 10, 2*math.sin(angle))
			end
		end
	end
	local _Terraform = self.Terraform
	self.Terraform = function(self, pt)
		if self:CanTerraformPoint(pt) == false then
			return false
		end
		local ground = GLOBAL.GetWorld()
		local original_tile_type = ground.Map:GetTileAtPoint(pt.x, pt.y, pt.z)
		local ret = _Terraform(self, pt)
		if ret == true then
			local turf_prefab = WHARANG_TURFS[original_tile_type] 
			if turf_prefab ~= nil then
				SpawnTurf(turf_prefab, pt) 
			end
			return true
		end
		return false
	end   end)
	]]
----------------------------------------------------------------
-- Cook Ingredient Values
----------------------------------------------------------------
if G.IsSW == false then
AddIngredientValues( {"wharang_dango"}, {dango=1} )

AddIngredientValues( {"redgoldfish", "blackgoldfish", "redgoldfish_cooked", "blackgoldfish_cooked"}, {meat=.5, fish=1.0} )

AddIngredientValues( {"rope"}, {rope=1} )

----------------------------------------------------------------
-- Cook Recipes
----------------------------------------------------------------

local SongPyeon = {
	name = "songpyeon",
	test = function(cooker, names, tags) return (tags.dango and tags.dango >= 1) and (names.berries and names.berries >= 2) end,
	priority = 50,
	weight = 1,
	foodtype = "VEGGIE",
	health = 20,
	hunger = 75,
	sanity = 25,
	perishtime = TUNING.PERISH_SUPERSLOW,
	cooktime = 2,
}

AddCookerRecipe("cookpot", SongPyeon)

local DriedCroaker = {
	name = "driedcroaker",
	test = function(cooker, names, tags) return (names.rope and names.rope >= 1) and (tags.fish and tags.fish >= 2) end,
	priority = 15,
	weight = 1,
	foodtype = "MEAT",
	health = 40,
	hunger = 80,
	sanity = 5,
	perishtime = TUNING.PERISH_MED,
	cooktime = 2.5,
}

AddCookerRecipe("cookpot", DriedCroaker)

elseif G.IsSW  == true then

----------------------------------------------------------------
-- Wally Intro
----------------------------------------------------------------

local function WharangWallyIntro(inst)
    if GLOBAL.GetPlayer().prefab == "wharang" then
	
	local function TakeOff(inst)
		local bird = SpawnPrefab("wallyintro_bird")
		bird.Transform:SetPosition(inst:GetPosition():Get())
		bird.Transform:SetRotation(inst.Transform:GetRotation())
		bird.AnimState:PlayAnimation("takeoff_diagonal_pre")
		local toplayer = (GetPlayer():GetPosition() - inst:GetPosition()):Normalize()

		bird.animoverfn = function()
			bird:RemoveEventCallback("animover", bird.animoverfn)

			bird.AnimState:PlayAnimation("takeoff_diagonal_loop", true)

			bird:DoTaskInTime(2, function() bird:Remove() end)

			bird:DoPeriodicTask(7 * FRAMES, function()
				bird.SoundEmitter:PlaySound("dontstarve/birds/flyin")
			end)

			bird:DoPeriodicTask(0, function()
				local currentpos = bird:GetPosition()
				local flightspeed = 7.5
				local posdelta = Vector3(toplayer.x * flightspeed, flightspeed, toplayer.z * flightspeed) * FRAMES
				local newpos = currentpos + posdelta
				bird.Transform:SetPosition(newpos:Get())
			end)
		end

		bird:ListenForEvent("animover", bird.animoverfn)
		
		local mast = SpawnPrefab("wallyintro_shipmast")
		mast.Transform:SetPosition(inst:GetPosition():Get())
		mast.Transform:SetRotation(inst.Transform:GetRotation())
		
		inst:Remove()
	end
        inst.components.maxwelltalker.speeches.SHIPWRECKED_1 =
        {
			voice = "dontstarve_DLC002/creatures/parrot/chirp",
			idleanim= "idle",
			dialoganim="speak",
			disappearanim = TakeOff,
			disableplayer = true,
			skippable = true,
			{
				string = nil,
				wait = 1,
				anim = "idle",
				pushanim = true,
				sound = nil,
			},
			{
				string = STRINGS.WHARANG_INTRO_WALLY_1,
				wait = 2,
				anim = nil,
				sound = nil,
			},
			{
				string = nil,
				wait = 3,
				anim = "idle_peck",
				pushanim = true,
				sectionfn = function(inst)
					inst:ListenForEvent("animover", PlayPecks)
				end,
			},
			{
				string = STRINGS.WHARANG_INTRO_WALLY_2, 
				wait = 2, 
				anim = nil, 
				sound = nil,
			},
        }
    end
end

AddPrefabPostInit("wallyintro", WharangWallyIntro)

end

----------------------------------------------------------------
-- Pet Action
----------------------------------------------------------------

ACTIONS.PETSTAY = GLOBAL.Action({mount_enabled=true}, 2, true, true)

ACTIONS.PETSTAY.fn = function(act)
local tar = act.target
	if tar and tar.components.petstay and tar.sg:HasStateTag("idle") then
		act.doer.components.talker:Say(GetString(act.doer.prefab, "ANNOUNCE_PETSTAY"))
		tar.components.combat:GiveUp()
		tar:AddTag("stay")
		tar:AddTag("shadow")
		tar:AddTag("notarget")
		tar:AddTag("growstop")
		if tar.components.health then
		tar.components.health.invincible = true
		end
		tar.components.petstay:SetStaying(true)
		tar.components.petstay:RememberStayPos("stayspos", GLOBAL.Point(tar.Transform:GetWorldPosition())) 
	return true
	elseif tar and tar.components.petstay and not tar.sg:HasStateTag("idle") then
		act.doer.components.talker:Say(GetString(act.doer.prefab, "ANNOUNCE_PETSTAY_NO"))
	end
end

ACTIONS.PETSTAY.str = STRINGS.ACTIONS.PETSTAY
ACTIONS.PETSTAY.id = "PETSTAY"
ACTIONS.PETSTAY_CANCEL = GLOBAL.Action({mount_enabled=true}, 2, true, true)

ACTIONS.PETSTAY_CANCEL.fn = function(act)
	local tar = act.target
	if tar and tar.components.petstay then
		act.doer.components.locomotor:Stop()
		tar:RemoveTag("stay")
		tar:RemoveTag("shadow")
		tar:RemoveTag("notarget")
		tar:RemoveTag("growstop")
		if tar.components.health then
		tar.components.health.invincible = false
		end
		act.doer.components.talker:Say(GetString(act.doer.prefab, "ANNOUNCE_PETSTAY_CANCEL"))
		tar.components.petstay:SetStaying(false)
		return true
	end
end

ACTIONS.PETSTAY_CANCEL.str = STRINGS.ACTIONS.PETSTAY_CANCEL
ACTIONS.PETSTAY_CANCEL.id = "PETSTAY_CANCEL"

----------------------------------------------------------------
-- Open Wall Action
----------------------------------------------------------------

local OPENWALL = Action({mount_enabled=true}, 3)
OPENWALL.str = STRINGS.ACTIONS.OPENWALL
OPENWALL.id = "OPENWALL"
OPENWALL.fn = function(act)
	local tar = act.target
    if tar and tar.components.walldoors and not tar.components.walldoors:IsOpen() then
		tar.components.walldoors:OpenWall(tar)
		return true
    end
end

AddAction(OPENWALL)
AddStategraphActionHandler("wilson", ActionHandler(OPENWALL, "give"))

local CLOSEWALL = Action({mount_enabled=true}, 3)
CLOSEWALL.str = STRINGS.ACTIONS.CLOSEWALL
CLOSEWALL.id = "CLOSEWALL"
CLOSEWALL.fn = function(act)
	local tar = act.target
    if tar and tar.components.walldoors and tar.components.walldoors:IsOpen() then
        tar.components.walldoors:CloseWall(tar)
        return true
    end
end

AddAction(CLOSEWALL)
AddStategraphActionHandler("wilson", ActionHandler(CLOSEWALL, "give"))

----------------------------------------------------------------
-- Miho Build
----------------------------------------------------------------

local function changemihobuild_new(inst)
    inst.AnimState:SetBank("fox_miho")
    inst.AnimState:SetBuild("fox_miho")
end

local function changemihobuild_old(inst)
    inst.AnimState:SetBank("miho")
    inst.AnimState:SetBuild("mihoup")
end

if Miho_Build == "old" then

	AddPrefabPostInit("miho", changemihobuild_old)
	
elseif Miho_Build == "new" then

	AddPrefabPostInit("miho", changemihobuild_new)
end

----------------------------------------------------------------
-- Collect Soul Heart
----------------------------------------------------------------

Player_Collect_SoulHeart = function() 
	if GetPlayer().soulheart < TUNING.SOULHEART_MAX then
		GetPlayer().components.talker:Say((GetString(GetPlayer().prefab, "DESC_SOULCOLLECT")).." "..(GetPlayer().soulheart).." "..(GetString(GetPlayer().prefab, "DESC_SOULHEART")).."\n("..(math.floor(GetPlayer().soulspirit/10)).."% "..(GetString(GetPlayer().prefab, "DESC_SOULCOLLECT_SPIRIT"))..")")
	else
		GetPlayer().components.talker:Say(GetString(GetPlayer().prefab, "DESC_SOULCOLLECT_ALL"))
	end
end

TheInput:AddControlHandler(G.CONTROL_FOCUS_UP, function(down)
	if GetPlayer() and GetPlayer().prefab == "wharang" then
		if down then
			if TheInput:IsControlPressed(G.CONTROL_INSPECT) then
				Player_Collect_SoulHeart()
			end
		end
	end
end)

function Key_Options_SoulHeart()
	if not IsPaused() then
		if GetPlayer() and GetPlayer().prefab == "wharang" then
			Player_Collect_SoulHeart()
		end
	end
end

TheInput:AddKeyDownHandler(Collect_SoulHeart, Key_Options_SoulHeart)

----------------------------------------------------------------
-- Party Action
----------------------------------------------------------------

Start_BurnPartyTime = function() 
	if GetPlayer().soulheart >= 100 then
		if GetPlayer().components.sanity.current >= TUNING.SOULHEART_FIREWORK_NEEDS_SAN then
				if not GetPlayer():HasTag("PartyEnd") then
					if not GetPlayer():HasTag("FireFoxAttack") then
						GetPlayer():AddTag("FireFoxAttack")
						GetPlayer().components.talker:Say(GetString(GetPlayer().prefab,"ANNOUNCE_CAN_PARTY"))
					elseif GetPlayer():HasTag("FireFoxAttack") then
						GetPlayer():RemoveTag("FireFoxAttack")
						GetPlayer().components.talker:Say(GetString(GetPlayer().prefab,"ANNOUNCE_END_PARTY"))
					end
				elseif GetPlayer():HasTag("PartyEnd") then
					GetPlayer().components.talker:Say((GetString(GetPlayer().prefab,"ANNOUNCE_NO_TIME_PARTY"))..(GetPlayer().PartyTime)..(GetString(GetPlayer().prefab,"ANNOUNCE_NO_TIME_PARTY2")))
				end
		elseif GetPlayer().components.sanity.current < TUNING.SOULHEART_FIREWORK_NEEDS_SAN then
			if GetPlayer():HasTag("PartyEnd") then
				GetPlayer().components.talker:Say((GetString(GetPlayer().prefab,"ANNOUNCE_NO_TIME_PARTY"))..(GetPlayer().PartyTime)..(GetString(GetPlayer().prefab,"ANNOUNCE_NO_TIME_PARTY2")))
			elseif not GetPlayer():HasTag("PartyEnd") then
				GetPlayer().components.talker:Say(GetString(GetPlayer().prefab, "ANNOUNCE_NO1_PARTY")) end
		end
	elseif GetPlayer().soulheart < 100 then
		GetPlayer().components.talker:Say(GetString(GetPlayer().prefab, "ANNOUNCE_NO2_PARTY"))
	end
end

function Key_Options_PartyTime()
	if not IsPaused() and not TheInput:IsKeyDown(G.KEY_CTRL) and not TheInput:IsKeyDown(G.KEY_ALT) and TheInput:IsKeyDown(G.KEY_SHIFT) then
		if GetPlayer() and GetPlayer().prefab == "wharang" then
			Start_BurnPartyTime()
		end
	end
end

TheInput:AddKeyDownHandler(BurnPartyTime, Key_Options_PartyTime)

----------------------------------------------------------------
-- Pet Call Action
----------------------------------------------------------------

pet_call = function() 
	if not GetPlayer():HasTag("callpet") then GetPlayer():AddTag("callpet")
		GetPlayer().components.talker:Say(GetString(GetPlayer().prefab, "ANNOUNCE_PRIORITY_FOLLOW"))
			local pos = Vector3(GetPlayer().Transform:GetWorldPosition()) pos.y = pos.y + 2.5
			local FL_Fx = SpawnPrefab("dr_warm_loop_2")
		FL_Fx.Transform:SetPosition(pos:Get()) FL_Fx.Transform:SetScale(2.3,2.3,2.3)
	elseif GetPlayer():HasTag("callpet") then GetPlayer():RemoveTag("callpet")
		GetPlayer().components.talker:Say(GetString(GetPlayer().prefab, "ANNOUNCE_PRIORITY_FIGHT"))
			local pos = Vector3(GetPlayer().Transform:GetWorldPosition()) pos.y = pos.y + 2.5
			local FF_Fx = SpawnPrefab("dr_hot_loop")
		FF_Fx.Transform:SetPosition(pos:Get()) FF_Fx.Transform:SetScale(1.8,1.8,1.8)
	end
end

function Key_Options_Call_Pets() if not IsPaused() and not TheInput:IsKeyDown(G.KEY_ALT) and not TheInput:IsKeyDown(G.KEY_SHIFT) and TheInput:IsKeyDown(G.KEY_CTRL) then
	if GetPlayer() and GetPlayer().prefab == "wharang" then pet_call() end end end
TheInput:AddKeyDownHandler(Options_CallPet, Key_Options_Call_Pets)
function CTR_Key_Options_Call_Pets() if GetPlayer() and GetPlayer().prefab == "wharang" then pet_call() end end
TheInput:AddControlHandler(G.CONTROL_INSPECT, function(down) if down then if TheInput:IsControlPressed(G.CONTROL_FOCUS_UP) or TheInput:IsControlPressed(G.CONTROL_FORCE_INSPECT) then CTR_Key_Options_Call_Pets() end end end)

----------------------------------------------------------------
-- Wharang TUNING
----------------------------------------------------------------

TUNING.WHARANG_HEALTH_S = 80
TUNING.WHARANG_HUNGER_S = 85
TUNING.WHARANG_SANITY_S = 150

TUNING.WHARANG_HEALTH_PLUS = .4
TUNING.WHARANG_HUNGER_PLUS = .2
TUNING.WHARANG_SANITY_PLUS = .5


if Wharang_Stats == "stat_default" then
TUNING.WHARANG_HEALTH_S = 80
TUNING.WHARANG_HUNGER_S = 85
TUNING.WHARANG_SANITY_S = 150
TUNING.WHARANG_HEALTH_PLUS = .4
TUNING.WHARANG_HUNGER_PLUS = .2
TUNING.WHARANG_SANITY_PLUS = .5
elseif Wharang_Stats == "stat_beginner" then
TUNING.WHARANG_HEALTH_S = 180
TUNING.WHARANG_HUNGER_S = 185
TUNING.WHARANG_SANITY_S = 200
TUNING.WHARANG_HEALTH_PLUS = .4 --380
TUNING.WHARANG_HUNGER_PLUS = .2 --285
TUNING.WHARANG_SANITY_PLUS = .5
end